/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include <nnhk.h>

#include <stdio.h>
#include <time.h>
#include <math.h>

#include <windows.h> /* Sleep() */

#include "zaaklad/font.h"

#define CLOCKS_PER_MS (CLOCKS_PER_SEC / 1000.0)

static void kresli(unsigned long *pixely)
{
    int i;

    for (i = 0; i < 640 * 640; i++)
    {
        pixely[i] = 0x00ffffff;
    }
}

int main()
{
    NNHK_OKNO *okno;
    NNHK_POVRCH *povrch;
    int cyklus;
    double cshas_za_sniimku; /* V ms. */
    double akumulovanee_ms = 0;
    void *font;

#error Nenastavenyy fontovyy suubor!
    font = fontNacshitaj("Font.otf");
    if (font == NULL) return (0);
    printf("font hotovo\n");

    nnhk_inic();

    okno = nnhk_VytvorOkno("Text teraz",
                           0, 0, 640, 640,
                           NNHK_OKNO_VIDITHELNEE);

    if (okno == NULL) printf("zle!\n");

    povrch = nnhk_dajOknaPovrch(okno);

    if (povrch == NULL) printf("zle!!\n");


    kresli(povrch->pixely);
    fontZobrazZnak(font, 0, povrch->pixely);
    printf("hotovo\n");

    nnhk_aktualizujOkno(okno);

    cyklus = 1;
    while (cyklus)
    {
        clock_t shtart = clock();

        while(akumulovanee_ms >= 50)
        {
            UDALOSTH u;

            while (udalosthOdober(&u) != 0)
            {
                switch (u.typ) {
                    case NNHK_KONIEC: {
                        cyklus = 0;
                        break;
                    }
                }
            }

            akumulovanee_ms -= 50;
        }

        /*kresli(povrch->pixely);
        fontZobrazZnak(font, 0, povrch->pixely);

        nnhk_aktualizujOkno(okno);*/

        /* Limituje SZS na 60. */
        cshas_za_sniimku = (clock() - shtart) / CLOCKS_PER_MS;
        if (cshas_za_sniimku < 16)
        {
            Sleep((16 - cshas_za_sniimku));
        }

        cshas_za_sniimku = (clock() - shtart) / CLOCKS_PER_MS;
        akumulovanee_ms += cshas_za_sniimku;
    }

    nnhk_ZnicshOkno(okno);

    nnhk_koniec();

    fontUvolhni(font);
    printf("koniec\n");

    return (0);
}

