/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include "analyz.h"

#include <stdio.h>
#include <stdlib.h>

#include "../zaaklad/typy.h"
#include "../taby/taby.h"
#include "../cff/cff.h"

#define k32(u) ((((u) >> 24) & 0x000000ff) \
                | (((u) << 8) & 0x00ff0000) \
                | (((u) >> 8) & 0x0000ff00) \
                | (((u) << 24) & 0xff000000))

#define k16(u) ((((u) << 8) & 0xff00) \
                | (((u) >> 8) & 0x00ff))

static USHORT ushortMax(USHORT a, USHORT b)
{
    return (a > b ? a : b);
}

unsigned long cshTag(FILE *f)
{
    unsigned long tag;

    if (fread(&tag, 4, 1, f) != 1)
    {
        printf("Chyba pri cshiitanii Tag!\n");
    }

    return (tag);
}

BYTE cshByte(FILE *f)
{
    BYTE b;

    if (fread(&b, sizeof(BYTE), 1, f) != 1)
    {
        printf("Chyba pri cshiitanii BYTE!\n");
    }

    return (b);
}

CHAR cshChar(FILE *f)
{
    CHAR c;

    if (fread(&c, sizeof(CHAR), 1, f) != 1)
    {
        printf("Chyba pri cshiitanii CHAR!\n");
    }

    return (c);
}

USHORT cshUshort(FILE *f)
{
    USHORT us;

    if (fread(&us, sizeof(USHORT), 1, f) != 1)
    {
        printf("Chyba pri cshiitanii USHORT!\n");
    }
    us = k16(us);

    return (us);
}

SHORT cshShort(FILE *f)
{
    SHORT s;

    if (fread(&s, sizeof(USHORT), 1, f) != 1)
    {
        printf("Chyba pri cshiitanii SHORT!\n");
    }
    s = k16(s);

    return (s);
}

ULONG cshUlong(FILE *f)
{
    ULONG ul;

    if (fread(&ul, sizeof(ULONG), 1, f) != 1)
    {
        printf("Chyba pri cshiitanii ULONG!\n");
    }
    ul = k32(ul);

    return (ul);
}

Fixed cshFixed(FILE *f)
{
    return (cshUlong(f));
}

void cshLongdatetime(FILE *f, LONGDATETIME *ldt)
{
    int i;
    unsigned char pldt[8];

    if (fread(pldt, 8, 1, f) != 1)
    {
        printf("Chyba pri cshiitanii LONGDATETIME!\n");
    }

    for (i = 0; i < 8; i++)
    {
        ldt->daata[i] = pldt[7 - i];
    }
}

#define cshFword cshShort
#define cshUfword cshUshort

int neviemNaazovFunkcie(FONT *font)
{
    int i;

    if (fseek(font->f, 0, SEEK_SET) != 0)
    {
        printf("Chyba pri fseeeku!\n");
    }

    font->sfnt_version = cshFixed(font->f);
    font->numTables = cshUshort(font->f);
    font->searchRange = cshUshort(font->f);
    font->entrySelector = cshUshort(font->f);
    font->rangeShift = cshUshort(font->f);

    font->taby = calloc(font->numTables, sizeof(*(font->taby)));
    if (font->taby == NULL)
    {
        printf("Nepodarilo sa alokovath pamaeth!\n");
        return (1);
    }

    for (i = 0; i < font->numTables; i++)
    {
        font->taby[i].tag = cshUlong(font->f);
        font->taby[i].checkSum = cshUlong(font->f);
        font->taby[i].Offset = cshUlong(font->f);
        font->taby[i].length = cshUlong(font->f);

        font->taby[i].stav = STAV_NEHOTOVEE;
    }

    print_font(font);

    return (0);
}

int cshiitaj_cmap_subtab(FONT *font, CMAP_SUBTAB *cs)
{
    cs->format = cshUshort(font->f);

    if (cs->format < 8)
    {
        cs->length = cshUshort(font->f);
        cs->language = cshUshort(font->f);
    }
    else if (cs->format <= 12)
    {
        cs->length = cshUshort(font->f);
        /* reserved = */ cshUshort(font->f);
        cs->language = cshUshort(font->f);
    }
    else
    {
        cs->length = cshUshort(font->f);
        cs->language = 0;
    }

    cs->pocshetIndexov = 0;
    cs->glyf_indexy = NULL;

    switch (cs->format) {
        case 4: {
            USHORT segCountX2;
#if 0
            USHORT searchRange;
            USHORT entrySelector;
            USHORT rangeShift;
#endif

            USHORT *endCode;
            USHORT *startCode;
            SHORT *idDelta;
            USHORT *idRangeOffset;
            USHORT segCount;

            int seg, znak;

            segCountX2 = cshUshort(font->f);
#if 0
            searchRange = cshUshort(font->f);
            entrySelector = cshUshort(font->f);
            rangeShift = cshUshort(font->f);
#else
            cshUshort(font->f);
            cshUshort(font->f);
            cshUshort(font->f);
#endif

            segCount = segCountX2 / 2;

            endCode = malloc(sizeof(*endCode) * segCount);
            startCode = malloc(sizeof(*startCode) * segCount);
            idDelta = malloc(sizeof(*idDelta) * segCount);
            idRangeOffset = malloc(sizeof(*idRangeOffset) * segCount);
            if (endCode == NULL || startCode == NULL
                || idDelta == NULL || idRangeOffset == NULL)
            {
                printf("Nepodarilo sa alokovath pamaeth!\n");

                if (endCode) free(endCode);
                if (startCode) free(startCode);
                if (idDelta) free(idDelta);
                if (idRangeOffset) free(idRangeOffset);
                return (1);
            }

            for (seg = 0; seg < segCount; seg++)
            {
                endCode[seg] = cshUshort(font->f);
            }

            /* reservedPad = */ cshUshort(font->f);

            for (seg = 0; seg < segCount; seg++)
            {
                startCode[seg] = cshUshort(font->f);
            }

            for (seg = 0; seg < segCount; seg++)
            {
                idDelta[seg] = cshShort(font->f);
            }

            for (seg = 0; seg < segCount; seg++)
            {
                idRangeOffset[seg] = cshUshort(font->f);
            }

            cs->pocshetIndexov = 0x10000;
            cs->glyf_indexy = calloc(0x10000, sizeof(*(cs->glyf_indexy)));
            if (cs->glyf_indexy == NULL)
            {
                printf("Nepodarilo sa alokovath pamaeth!\n");

                free(endCode);
                free(startCode);
                free(idDelta);
                free(idRangeOffset);

                return (1);
            }

            for (znak = 0; znak < 0x10000; znak++)
            {
                for (seg = 0; seg < segCount; seg++)
                {
                    if (znak <= endCode[seg])
                    {
                        if (znak >= startCode[seg])
                        {
                            if (idRangeOffset[seg] == 0)
                            {
                                cs->glyf_indexy[znak] = ((idDelta[seg] + znak)
                                                         % 65536);
                            }
                            else
                            {
                                printf("idRangeOffset[seg] nie je 0\n");
                            }
                        }
                        else
                        {
                            cs->glyf_indexy[znak] = 0;
                        }
                        break;
                    }
                }
            }

            free(endCode);
            free(startCode);
            free(idDelta);
            free(idRangeOffset);

            return (0);
        }

        default: {
            printf("Neznaamy formaat: %u\n", cs->format);
            return (0);
        }
    }
}

int cshiitaj_cmap(FONT *font, TABLE_RECORD *tab)
{
    CMAP_TAB *cmap = &(tab->daata.cmap);
    int i;

    cmap->Version = cshUshort(font->f);
    cmap->numTables = cshUshort(font->f);

    cmap->cmap_subtaby = calloc(cmap->numTables,
                                sizeof(*(cmap->cmap_subtaby)));
    if (cmap->cmap_subtaby == NULL)
    {
        printf("Nepodarilo sa alokovath pamaeth!\n");
        return (1);
    }

    for (i = 0; i < cmap->numTables; i++)
    {
        CMAP_SUBTAB *cs = &(cmap->cmap_subtaby[i]);
        long poziicia;

        cs->platformID = cshUshort(font->f);
        cs->encodingID = cshUshort(font->f);
        cs->Offset = cshUlong(font->f);

        poziicia = ftell(font->f);
        if (poziicia == -1L)
        {
            printf("Chyba pri ftelle!\n");
            return (1);
        }

        if (fseek(font->f, tab->Offset + (cs->Offset), SEEK_SET) != 0)
        {
            printf("Chyba pri fseeeku!\n");
            return (1);
        }

        cshiitaj_cmap_subtab(font, cs);

        if (fseek(font->f, poziicia, SEEK_SET) != 0)
        {
            printf("Chyba pri fseeeku!\n");
            return (1);
        }
    }

    return (0);
}

int cshiitaj_head(FONT *font, TABLE_RECORD *tab)
{
    HEAD_TAB *head = &(tab->daata.head);

    head->Table_version_number = cshFixed(font->f);
    head->fontRevision = cshFixed(font->f);
    head->checkSumAdjustment = cshUlong(font->f);
    head->magicNumber = cshUlong(font->f);
    head->flags = cshUshort(font->f);
    head->unitsPerEm = cshUshort(font->f);
    cshLongdatetime(font->f, &(head->created));
    cshLongdatetime(font->f, &(head->modified));
    head->xMin = cshShort(font->f);
    head->yMin = cshShort(font->f);
    head->xMax = cshShort(font->f);
    head->yMax = cshShort(font->f);
    head->macStyle = cshUshort(font->f);
    head->lowestRecPPEM = cshUshort(font->f);
    head->fontDirectionHint = cshShort(font->f);
    head->indexToLocFormat = cshShort(font->f);
    head->glyphDataFormat = cshShort(font->f);

    return (0);
}

int cshiitaj_hhea(FONT *font, TABLE_RECORD *tab)
{
    HHEA_TAB *hhea = &(tab->daata.hhea);

    hhea->Table_version_number = cshFixed(font->f);
    hhea->Ascender = cshFword(font->f);
    hhea->Descender = cshFword(font->f);
    hhea->LineGap = cshFword(font->f);
    hhea->advanceWidthMax = cshUfword(font->f);

    hhea->minLeftSideBearing = cshFword(font->f);
    hhea->minRightSideBearing = cshFword(font->f);
    hhea->xMaxExtend = cshFword(font->f);

    hhea->caretSlopeRise = cshShort(font->f);
    hhea->caretSlopeRun = cshShort(font->f);
    hhea->caretOffset = cshShort(font->f);

    /* hhea->reserved = */ cshShort(font->f);
    /* hhea->reserved = */ cshShort(font->f);
    /* hhea->reserved = */ cshShort(font->f);
    /* hhea->reserved = */ cshShort(font->f);

    hhea->metricDataFormat = cshShort(font->f);
    hhea->numberOfHMetrics = cshUshort(font->f);

    return (0);
}

int cshiitaj_hmtx(FONT *font, TABLE_RECORD *tab)
{
    HMTX_TAB *hmtx = &(tab->daata.hmtx);
    HHEA_TAB *hhea;
    MAXP_TAB *maxp;
    int i;

    hhea = daj_hhea(font);
    if (hhea == NULL)
    {
        printf("Chyyba hhea tab.!\n");
        return (1);
    }

    maxp = daj_maxp(font);
    if (maxp == NULL)
    {
        printf("Chyyba maxp tab.!\n");
        return (1);
    }

    hmtx->hMetrics = calloc(hhea->numberOfHMetrics, sizeof(*(hmtx->hMetrics)));

    if (hmtx->hMetrics == NULL)
    {
        printf("Nepodarilo sa alokovath pamaeth!\n");
        return (1);
    }

    hmtx->leftSideBearing = calloc(maxp->numGlyphs - (hhea->numberOfHMetrics),
                                   sizeof(*(hmtx->leftSideBearing)));

    if (hmtx->leftSideBearing == NULL)
    {
        printf("Nepodarilo sa alokovath pamaeth!\n");
        return (1);
    }

    for (i = 0; i < hhea->numberOfHMetrics; i++)
    {
        hmtx->hMetrics[i].advanceWidth = cshUshort(font->f);
        hmtx->hMetrics[i].lsb = cshShort(font->f);
    }

    for (i = 0; i < maxp->numGlyphs - (hhea->numberOfHMetrics); i++)
    {
        hmtx->leftSideBearing[i] = cshShort(font->f);
    }

    return (0);
}

int cshiitaj_maxp(FONT *font, TABLE_RECORD *tab)
{
    MAXP_TAB *maxp = &(tab->daata.maxp);

    maxp->Table_version_number = cshFixed(font->f);
    maxp->numGlyphs = cshUshort(font->f);
    if (maxp->Table_version_number == MAXP_TRUETYPE)
    {
        maxp->maxPoints = cshUshort(font->f);
        maxp->maxContours = cshUshort(font->f);
        maxp->maxCompositePoints = cshUshort(font->f);
        maxp->maxCompositeContours = cshUshort(font->f);
        maxp->maxZones = cshUshort(font->f);
        maxp->maxTwilightPoints = cshUshort(font->f);
        maxp->maxStorage = cshUshort(font->f);
        maxp->maxFunctionDefs = cshUshort(font->f);
        maxp->maxInstructionDefs = cshUshort(font->f);
        maxp->maxStackElements = cshUshort(font->f);
        maxp->maxSizeOfInstructions = cshUshort(font->f);
        maxp->maxComponentElements = cshUshort(font->f);
        maxp->maxComponentDepth = cshUshort(font->f);
    }

    return (0);
}

int cshiitaj_os_2(FONT *font, TABLE_RECORD *tab)
{
    OS_2_TAB *os_2 = &(tab->daata.os_2);

    os_2->Version = cshUshort(font->f);
    os_2->xAvgCharWidth = cshShort(font->f);
    os_2->usWeightClass = cshUshort(font->f);
    os_2->usWidthClass = cshUshort(font->f);
    os_2->fsType = cshUshort(font->f);
    os_2->ySubscriptXSize = cshShort(font->f);
    os_2->ySubscriptYSize = cshShort(font->f);
    os_2->ySubscriptXOffset = cshShort(font->f);
    os_2->ySubscriptYOffset = cshShort(font->f);
    os_2->ySuperscriptXSize = cshShort(font->f);
    os_2->ySuperscriptYSize = cshShort(font->f);
    os_2->ySuperscriptXOffset = cshShort(font->f);
    os_2->ySuperscriptYOffset = cshShort(font->f);
    os_2->yStrikeoutSize = cshShort(font->f);
    os_2->yStrikeoutPosition = cshShort(font->f);
    os_2->sFamilyClass = cshShort(font->f);

    {
        int i;
        for (i = 0; i < sizeof(os_2->Panose) / sizeof(os_2->Panose[0]); i++)
        {
            os_2->Panose[i] = cshByte(font->f);
        }
    }

    os_2->ulUnicodeRange1 = cshUlong(font->f);
    if (os_2->Version >= 0x0001)
    {
        os_2->ulUnicodeRange2 = cshUlong(font->f);
        os_2->ulUnicodeRange3 = cshUlong(font->f);
        os_2->ulUnicodeRange4 = cshUlong(font->f);
    }

    {
        int i;
        for (i = 0;
             i < sizeof(os_2->achVendID) / sizeof(os_2->achVendID[0]);
             i++)
        {
            os_2->achVendID[i] = cshChar(font->f);
        }
    }

    os_2->fsSelection = cshUshort(font->f);
    os_2->usFirstCharIndex = cshUshort(font->f);
    os_2->usLastCharIndex = cshUshort(font->f);
    os_2->sTypoAscender = cshShort(font->f);
    os_2->sTypoDescender = cshShort(font->f);
    os_2->sTypoLineGap = cshShort(font->f);
    os_2->usWinAscent = cshUshort(font->f);
    os_2->usWinDescent = cshUshort(font->f);

    if (os_2->Version >= 0x0001)
    {
        os_2->ulCodePageRange1 = cshUlong(font->f);
        os_2->ulCodePageRange2 = cshUlong(font->f);
    }

    if (os_2->Version >= 0x0002)
    {
        os_2->sxHeight = cshShort(font->f);
        os_2->sCapHeight = cshShort(font->f);
        os_2->usDefaultChar = cshUshort(font->f);
        os_2->usBreakChar = cshUshort(font->f);
        os_2->usMaxContext = cshUshort(font->f);
    }

    return (0);
}

int cshiitaj_post(FONT *font, TABLE_RECORD *tab)
{
    POST_TAB *post = &(tab->daata.post);

    post->Version = cshFixed(font->f);
    post->italicAngle = cshFixed(font->f);
    post->underlinePosition = cshFword(font->f);
    post->underlineThickness = cshFword(font->f);
    post->isFixedPitch = cshUlong(font->f);
    post->minMemType42 = cshUlong(font->f);
    post->maxMemType42 = cshUlong(font->f);
    post->minMemType1 = cshUlong(font->f);
    post->maxMemType1 = cshUlong(font->f);

    if (post->Version == 0x00010000)
    {
        printf("Neimplementovanee!\n");
    }
    if (post->Version == 0x00020000)
    {
        int i;
        USHORT numberNewGlyphs = 0;

        post->numberOfGlyphs = cshUshort(font->f);
        post->glyphNameIndex = calloc(post->numberOfGlyphs,
                                      sizeof(post->glyphNameIndex[0]));
        if (post->glyphNameIndex == NULL)
        {
            printf("Nepodarilo sa alokovath pamaeth!\n");
            return (1);
        }

        for (i = 0; i < post->numberOfGlyphs; i++)
        {
            post->glyphNameIndex[i] = cshUshort(font->f);
            numberNewGlyphs = ushortMax(numberNewGlyphs,
                                        post->glyphNameIndex[i]);
        }
        /* Prvyych 258 glyfov je v shtandarnej Makintosh sade. */
        numberNewGlyphs = numberNewGlyphs - 258 + 1;

        post->names = calloc(numberNewGlyphs, sizeof(post->names[0]));
        if (post->names == NULL)
        {
            printf("Nepodarilo sa alokovath pamaeth!\n");
            return (1);
        }

        for (i = 0; i < numberNewGlyphs; i++)
        {
            BYTE dllzhka = cshByte(font->f);
            int j;

            post->names[i] = calloc(dllzhka + 1, sizeof(post->names[i][0]));
            if (post->names[i] == NULL)
            {
                printf("Nepodarilo sa alokovath pamaeth!\n");
                return (1);
            }

            for (j = 0; j < dllzhka; j++)
            {
                post->names[i][j] = cshChar(font->f);
            }
            post->names[i][j] = '\0';
        }
    }

    return (0);
}

int cshiitaj_loca(FONT *font, TABLE_RECORD *tab)
{
    LOCA_TAB *loca = &(tab->daata.loca);
    HEAD_TAB *head;
    MAXP_TAB *maxp;
    int i;

    head = daj_head(font);
    if (head == NULL)
    {
        printf("Chyyba head tab.!\n");
        return (1);
    }

    maxp = daj_maxp(font);
    if (maxp == NULL)
    {
        printf("Chyyba maxp tab.!\n");
        return (1);
    }

    loca->Offsets = calloc(maxp->numGlyphs + 1, sizeof(loca->Offsets[0]));
    if (head->indexToLocFormat == 0)
    {
        for (i = 0; i < maxp->numGlyphs + 1; i++)
        {
            USHORT offset = cshUshort(font->f);
            loca->Offsets[i] = offset * 2;
        }
    }
    else if (head->indexToLocFormat == 1)
    {
        for (i = 0; i < maxp->numGlyphs + 1; i++)
        {
            loca->Offsets[i] = cshUlong(font->f);
        }
    }
    else
    {
        printf("Neznaamy head->indexToLocFormat: %i\n",
               head->indexToLocFormat);
        return (1);
    }

    return (0);
}

int cshiitaj_cvt(FONT *font, TABLE_RECORD *tab)
{
    CVT_TAB *cvt = &(tab->daata.cvt);
    int i;

    cvt->n = tab->length / sizeof(FWORD);
    cvt->hodnoty = calloc(cvt->n, sizeof(FWORD));
    if (cvt->hodnoty == NULL)
    {
        printf("Nepodarilo sa alokovath pamaeth!\n");
        return (1);
    }

    for (i = 0; i < cvt->n; i++)
    {
        cvt->hodnoty[i] = cshFword(font->f);
    }

    return (0);
}

int cshiitaj_fpgm(FONT *font, TABLE_RECORD *tab)
{
    FPGM_TAB *fpgm = &(tab->daata.fpgm);
    int i;

    fpgm->n = tab->length / sizeof(BYTE);
    fpgm->Instructions = calloc(fpgm->n, sizeof(BYTE));
    if (fpgm->Instructions == NULL)
    {
        printf("Nepodarilo sa alokovath pamaeth!\n");
        return (1);
    }

    for (i = 0; i < fpgm->n; i++)
    {
        fpgm->Instructions[i] = cshByte(font->f);
    }

    return (0);
}

int cshiitaj_prep(FONT *font, TABLE_RECORD *tab)
{
    PREP_TAB *prep = &(tab->daata.prep);
    int i;

    prep->n = tab->length / sizeof(BYTE);
    prep->Instructions = calloc(prep->n, sizeof(BYTE));
    if (prep->Instructions == NULL)
    {
        printf("Nepodarilo sa alokovath pamaeth!\n");
        return (1);
    }

    for (i = 0; i < prep->n; i++)
    {
        prep->Instructions[i] = cshByte(font->f);
    }

    return (0);
}

int cshiitaj_sgd(FONT *font, GLYPH *glyph)
{
    SIMPLE_GLYPH_DESCRIPTION *sgd = &(glyph->Description.sgd);
    int i;

    sgd->endPtsOfContours = calloc(glyph->numberOfContours,
                                   sizeof(sgd->endPtsOfContours[0]));
    if (sgd->endPtsOfContours == NULL)
    {
        printf("Nepodarilo sa alokovath pamaeth!\n");
        return (1);
    }

    for (i = 0; i < glyph->numberOfContours; i++)
    {
        sgd->endPtsOfContours[i] = cshUshort(font->f);
    }

    sgd->instructionLength = cshUshort(font->f);

    sgd->instructions = calloc(sgd->instructionLength,
                               sizeof(sgd->instructions[0]));
    if (sgd->instructions == NULL)
    {
        printf("Nepodarilo sa alokovath pamaeth!\n");
        return (1);
    }
    for (i = 0; i < sgd->instructionLength; i++)
    {
        sgd->instructions[i] = cshByte(font->f);
    }

    sgd->pocshetBodov = sgd->endPtsOfContours[glyph->numberOfContours - 1];

    sgd->flags = calloc(sgd->pocshetBodov, sizeof(sgd->flags[0]));
    sgd->xCoordinates = calloc(sgd->pocshetBodov,
                               sizeof(sgd->xCoordinates[0]));
    sgd->yCoordinates = calloc(sgd->pocshetBodov,
                               sizeof(sgd->yCoordinates[0]));

    if (sgd->flags == NULL
        || sgd->xCoordinates == NULL
        || sgd->yCoordinates == NULL)
    {
        printf("Nepodarilo sa alokovath pamaeth!\n");
        return (1);
    }
    {
        BYTE opakovanii = 0;
        BYTE flag;

        for (i = 0; i < sgd->pocshetBodov; i++)
        {
            if (opakovanii > 0)
            {
                opakovanii--;
                sgd->flags[i] = flag;
                continue;
            }
            flag = cshByte(font->f);
            sgd->flags[i] = flag;
            if (flag & FLAG_Repeat)
            {
                opakovanii = cshByte(font->f);
            }
        }
    }

    {
        SHORT hodnota = 0;
        for (i = 0; i < sgd->pocshetBodov; i++)
        {
            if (sgd->flags[i] & FLAG_x_Short_Vector)
            {
                if (sgd->flags[i] & FLAG_This_x_is_same)
                {
                    hodnota = (SHORT)cshByte(font->f);
                }
                else
                {
                    hodnota = -(SHORT)cshByte(font->f);
                }
            }
            else
            {
                if (sgd->flags[i] & FLAG_This_x_is_same)
                {
                    /* Zopakuje sa hodnota. */;
                }
                else
                {
                    hodnota = cshShort(font->f);
                }
            }
            sgd->xCoordinates[i] = hodnota;
        }

        hodnota = 0;
        for (i = 0; i < sgd->pocshetBodov; i++)
        {
            if (sgd->flags[i] & FLAG_y_Short_Vector)
            {
                if (sgd->flags[i] & FLAG_This_y_is_same)
                {
                    hodnota = (SHORT)cshByte(font->f);
                }
                else
                {
                    hodnota = -(SHORT)cshByte(font->f);
                }
            }
            else
            {
                if (sgd->flags[i] & FLAG_This_y_is_same)
                {
                    /* Zopakuje sa hodnota. */;
                }
                else
                {
                    hodnota = cshShort(font->f);
                }
            }
            sgd->yCoordinates[i] = hodnota;
        }
    }

    return (0);
}

int cshiitaj_glyph(FONT *font, GLYPH *glyph)
{
    glyph->numberOfContours = cshShort(font->f);
    glyph->xMin = cshShort(font->f);
    glyph->yMin = cshShort(font->f);
    glyph->xMax = cshShort(font->f);
    glyph->yMax = cshShort(font->f);

    if (glyph->numberOfContours == 0)
    {
        return (0);
    }
    else if (glyph->numberOfContours > 0)
    {
        cshiitaj_sgd(font, glyph);
    }
    else
    {
        /*printf("Compound\n");*/
    }

    return (0);
}

int cshiitaj_glyf(FONT *font, TABLE_RECORD *tab)
{
    GLYF_TAB *glyf = &(tab->daata.glyf);
    MAXP_TAB *maxp;
    LOCA_TAB *loca;
    int i;

    maxp = daj_maxp(font);
    if (maxp == NULL)
    {
        printf("Chyyba maxp tab.!\n");
        return (1);
    }

    loca = daj_loca(font);
    if (loca == NULL)
    {
        printf("Chyyba loca tab.!\n");
        return (1);
    }

    glyf->n = maxp->numGlyphs;

    glyf->glyphy = calloc(glyf->n, sizeof(glyf->glyphy[0]));
    if (glyf->glyphy == NULL)
    {
        printf("Nepodarilo sa alokovath pamaeth!\n");
        return (1);
    }

    for (i = 0; i < glyf->n; i++)
    {
        if (loca->Offsets[i + 1] - loca->Offsets[i] == 0)
        {
            continue;
        }
        if (fseek(font->f, tab->Offset + loca->Offsets[i], SEEK_SET) != 0)
        {
            printf("Chyba pri fseeeku!\n");
            return (1);
        }
        cshiitaj_glyph(font, glyf->glyphy + i);
    }

    return (0);
}

int cshiitaj_cff(FONT *font, TABLE_RECORD *tab)
{
    return (cffAnalyzuj(font, &(tab->daata.cff)));
}

int cshiitajTab(FONT *font, TABLE_RECORD *tab)
{
    int ret;

    if (fseek(font->f, tab->Offset, SEEK_SET) != 0)
    {
        printf("Chyba pri fseeeku!\n");
        return (1);
    }

    switch (tab->tag) {
        case TAG_CMAP: {
            ret = cshiitaj_cmap(font, tab);
            break;
        }

        case TAG_HEAD: {
            ret = cshiitaj_head(font, tab);
            break;
        }

        case TAG_HHEA: {
            ret = cshiitaj_hhea(font, tab);
            break;
        }

        case TAG_HMTX: {
            ret = cshiitaj_hmtx(font, tab);
            break;
        }

        case TAG_MAXP: {
            ret = cshiitaj_maxp(font, tab);
            break;
        }

        case TAG_NAME: {
            break;
        }

        case TAG_OS_2: {
            ret = cshiitaj_os_2(font, tab);
            break;
        }

        case TAG_POST: {
            ret = cshiitaj_post(font, tab);
            break;
        }

        case TAG_LOCA: {
            ret = cshiitaj_loca(font, tab);
            break;
        }

        case TAG_CVT: {
            ret = cshiitaj_cvt(font, tab);
            break;
        }

        case TAG_FPGM: {
            ret = cshiitaj_fpgm(font, tab);
            break;
        }

        case TAG_PREP: {
            ret = cshiitaj_prep(font, tab);
            break;
        }

        case TAG_GLYF: {
            ret = cshiitaj_glyf(font, tab);
            break;
        }

        case TAG_CFF: {
            ret = cshiitaj_cff(font, tab);
            break;
        }

        default: {
            tab->stav = STAV_NEZNAAME;
            return (0);
        }
    }

    if (ret == 0)
    {
        tab->stav = STAV_HOTOVEE;
    }
    else
    {
        tab->stav = STAV_CHYBA;
    }

    return (ret);
}

int cshiitajTaby(FONT *font)
{
    int ret;
    int i;
    unsigned long priority[] = {TAG_MAXP, TAG_HHEA, TAG_HEAD, TAG_LOCA};
    int pPriority = sizeof(priority) / sizeof(priority[0]);
    int iPriorita;

    for (iPriorita = 0; iPriorita < pPriority; iPriorita++)
    {
        for (i = 0; i < font->numTables; i++)
        {
            if (font->taby[i].tag == priority[iPriorita])
            {
                ret = cshiitajTab(font, font->taby + i);
                if (ret) return (ret);
                break;
            }
        }
    }

    for (i = 0; i < font->numTables; i++)
    {
        if (font->taby[i].stav != STAV_HOTOVEE)
        {
            cshiitajTab(font, font->taby + i);
        }
    }

    return (0);
}

int analyzSuubor(FONT *font, const char *meno)
{
    int ret;
    FILE *f = fopen(meno, "rb");

    if (f == NULL) return (1);

    font->f = f;

    ret = neviemNaazovFunkcie(font);
    if (ret)
    {
        fclose(f);
        return (ret);
    }

    ret = cshiitajTaby(font);
    if (ret)
    {
        fclose(f);
        return (ret);
    }

    fclose(f);
    return (0);
}
