/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#ifndef CFF_H
#define CFF_H

#include "../zaaklad/typy.h"

#define CFF_HEADER_MAJOR_VERSION 1

#define Top_DICT_version     0
#define Top_DICT_Notice      1
#define Top_DICT_FullName    2
#define Top_DICT_FamilyName  3
#define Top_DICT_Weight      4
#define Top_DICT_FontBBox    5
#define Top_DICT_charset     15
#define Top_DICT_Encoding    16
#define Top_DICT_CharStrings 17
#define Top_DICT_Private     (17 + 1)

#define Private_DICT_BlueValues        6
#define Private_DICT_OtherBlues        7
#define Private_DICT_FamilyBlues       8
#define Private_DICT_FamilyOtherBlues  9
#define Private_DICT_BlueScale         ((12 << 8) | 9)
#define Private_DICT_BlueShift         ((12 << 8) | 10)
#define Private_DICT_BlueFuzz          ((12 << 8) | 11)
#define Private_DICT_StdHW             10
#define Private_DICT_StdVW             11
#define Private_DICT_StemSnapH         ((12 << 8) | 12)
#define Private_DICT_StemSnapV         ((12 << 8) | 13)
#define Private_DICT_ForceBold         ((12 << 8) | (13 + 1))
#define Private_DICT_LanguageGroup     ((12 << 8) | 17)
#define Private_DICT_ExpansionFactor   ((12 << 8) | (17 + 1))
#define Private_DICT_initialRandomSeed ((12 << 8) | 19)
#define Private_DICT_Subrs             19
#define Private_DICT_defaultWidthX     20
#define Private_DICT_nominalWidthX     21

#define nStdStrings 391

typedef unsigned char Card8;
typedef unsigned short Card16;
typedef unsigned long Offset;
typedef unsigned char OffSize;
typedef unsigned short SID;

typedef struct {
    Card8 major;
    Card8 minor;
    Card8 hdrSize;
    OffSize offsize;
} Header;

typedef struct _dict_k {
    Card16 operator;
    Card8 *daata;
    unsigned long velkosth;
    struct _dict_k *dk;
} DICT_K;

typedef struct {
    DICT_K *z_dk;
    DICT_K *k_dk;
} DICT;

typedef struct {
    Card16 count;
    OffSize offSize;
    Offset *offset;
    Card8 *data;

    Offset *velkosti;
    Card8 **daata;
} INDEX;

typedef struct {
    Card8 format;
    union {
        SID *glyph;
    } daata;

    Card16 n;
} Charset;

typedef struct _cff {
    Header header;
    INDEX Name;
    INDEX Top_DICT;
    DICT Top;
    INDEX String;
    INDEX Global_Subr;
    DICT Private;
    INDEX Subr;
    INDEX CharStrings;
    Charset charset;

    long f_shtart;

    /* Uudaje pre praacu s CharStringami. */
    long defaultWidthX;
    long nominalWidthX;

    long bodX;
    long bodY;
    unsigned long *obraz;
} CFF;

int cffAnalyzuj(FONT *font, CFF_TAB *cff_tab);
void cffUvolhniCff(CFF_TAB *cff_tab);

#endif /* CFF_H */
