/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#ifndef CHARSTRING_H
#define CHARSTRING_H

#include "cff.h"

#define LIMIT_Argument_stack 48

#define ESCAPE 12

#define OP_hstem      1
#define OP_vstem      3
#define OP_vmoveto    4
#define OP_rlineto    5
#define OP_hlineto    6
#define OP_vlineto    7
#define OP_rrcurveto  8
#define OP_callsubr   10
#define OP_return     11
#define OP_endchar    (13 + 1)
#define OP_hstemhm    (17 + 1)
#define OP_hintmask   19
#define OP_cntrmask   20
#define OP_rmoveto    21
#define OP_hmoveto    22
#define OP_vstemhm    23
#define OP_rcurveline 24
#define OP_rlinecurve 25
#define OP_vvcurveto  26
#define OP_hhcurveto  27
#define OP_callgsubr  29
#define OP_vhcurveto  30
#define OP_hvcurveto  31

#define OP_and        ((12 << 8) | 3)
#define OP_or         ((12 << 8) | 4)
#define OP_not        ((12 << 8) | 5)
/* -Reserved- */
/* -Reserved- */
/* -Reserved- */
#define OP_abs        ((12 << 8) | 9)
#define OP_add        ((12 << 8) | 10)
#define OP_sub        ((12 << 8) | 11)
#define OP_div        ((12 << 8) | 12)
/* -Reserved- */
#define OP_neg        ((12 << 8) | (13 + 1))
#define OP_eq         ((12 << 8) | 15)
/* -Reserved- */
/* -Reserved- */
#define OP_drop       ((12 << 8) | (17 + 1))
/* -Reserved- */
#define OP_put        ((12 << 8) | 20)
#define OP_get        ((12 << 8) | 21)
#define OP_ifelse     ((12 << 8) | 22)
#define OP_random     ((12 << 8) | 23)
#define OP_mul        ((12 << 8) | 24)
/* -Reserved- */
#define OP_sqrt       ((12 << 8) | 26)
#define OP_dup        ((12 << 8) | 27)
#define OP_exch       ((12 << 8) | 28)
#define OP_index      ((12 << 8) | 29)
#define OP_roll       ((12 << 8) | 30)
/* -Reserved- */
/* -Reserved- */
/* -Reserved- */
#define OP_hflex      ((12 << 8) | 34)
#define OP_flex       ((12 << 8) | 35)
#define OP_hflex1     ((12 << 8) | 36)
#define OP_flex1      ((12 << 8) | 37)

#define CHSK_INT   28
#define CHSK_FIXED 255

typedef struct {
    int typ;
    long hodnota;
} CHSK;

int pracuj(CFF *cff, unsigned long *obraz);

#endif /* CHARSTRING_H */
