/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include "nnhk.h"

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

struct _nnhk_okno {
    HWND hwnd;
    NNHK_POVRCH *povrch;
};

static NNHK_OKNO *chytenee_okno = NULL;

static const unsigned char t_mapa[0x100] = {
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, VT_ESC,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, VT_VLHAVO, VT_HORE, VT_VPRAVO,
    VT_DOLE, 0, 0, 0,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, 0, VT_F, VT_G,
    VT_H, VT_I, VT_J, VT_K,
    VT_L, VT_M, VT_N, VT_O,

    VT_P, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,

    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0
};

static UDALOSTH *prvaa_udalosth = NULL;
static UDALOSTH *poslednaa_udalosth = NULL;

static long myshPredPozX;
static long myshPredPozY;

static UDALOSTH *udalosthPridaj(int typ)
{
    UDALOSTH *u;

    u = malloc(sizeof(UDALOSTH));
    if (u == NULL)
    {
        printf("Nepodarilo sa alokovath UDALOSTH\n");
        exit(-1);
    }

    u->typ = typ;
    u->dalshia = NULL;

    if (prvaa_udalosth)
    {
        poslednaa_udalosth->dalshia = u;
        poslednaa_udalosth = u;
    }
    else
    {
        prvaa_udalosth = u;
        poslednaa_udalosth = u;
    }

    return (u);
}

int udalosthOdober(UDALOSTH *uu)
{
    MSG msg;

    if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    if (prvaa_udalosth)
    {
        UDALOSTH *u = prvaa_udalosth;
        prvaa_udalosth = prvaa_udalosth->dalshia;

        *uu = *u;

        free(u);

        return (1);
    }

    return (0);
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    UDALOSTH *u;

    switch (msg) {
        case WM_KEYDOWN: {
            u = udalosthPridaj(STLACSHENEE_TLACSHIDLO);
            u->daata.tlacshidlo = t_mapa[wParam];

            break;
        }

        case WM_KEYUP: {
            u = udalosthPridaj(PUSTENEE_TLACSHIDLO);
            u->daata.tlacshidlo = t_mapa[wParam];

            break;
        }

        case WM_CLOSE: {
            u = udalosthPridaj(NNHK_KONIEC);

            break;
        }

        case WM_DESTROY: {
            PostQuitMessage(0);

            break;
        }

        case WM_CAPTURECHANGED: {
            u = udalosthPridaj(STRATA_DRZHANIA);

            break;
        }

        case WM_MOUSEMOVE: {
            POINT bod;
            long xPoz, yPoz;

            if (GetCursorPos(&bod) == 0) printf("zle\n");

            xPoz = bod.x;
            yPoz = bod.y;

            u = udalosthPridaj(MYSH_POHYB);
            u->daata.mysh_pohyb.poz.x = xPoz;
            u->daata.mysh_pohyb.poz.y = yPoz;
            u->daata.mysh_pohyb.rel.x = xPoz - myshPredPozX;
            u->daata.mysh_pohyb.rel.y = yPoz - myshPredPozY;

            if (chytenee_okno && (chytenee_okno->hwnd == hwnd))
            {
                long xStred, yStred;
                RECT rcOkno, rcClient;

                if (GetWindowRect(hwnd, &rcOkno) == 0
                    || GetClientRect(hwnd, &rcClient) == 0)
                {
                    printf("zle\n");
                }

                xStred = (rcOkno.right - rcClient.right) + rcClient.right / 2;
                yStred = ((rcOkno.bottom - rcClient.bottom)
                          + rcClient.bottom / 2);

                SetCursorPos(xStred, yStred);
                myshPredPozX = xStred;
                myshPredPozY = yStred;
            }
            else
            {
                myshPredPozX = xPoz;
                myshPredPozY = yPoz;
            }

            break;
        }

        default : {
            return DefWindowProc(hwnd, msg, wParam, lParam);

            break;
        }
    }

    return (0);
}

#define TEST (WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU)
#define TEST2 WS_OVERLAPPEDWINDOW

static const char g_szClassName[] = "mojaOknoTrieda";

static int _windowsVytvorOkno(NNHK_OKNO *okno,
                              const char *nadpis,
                              int xPoz, int yPoz,
                              int shiirka, int vyyshka,
                              int vlajky)
{
    WNDCLASSEX wc;
    HWND hwnd;
    RECT rect;
    HINSTANCE hInstance = GetModuleHandle(NULL);

    wc.cbSize = sizeof(wc);
    wc.style = 0;
    wc.lpfnWndProc = WndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
    wc.lpszMenuName = NULL;
    wc.lpszClassName = g_szClassName;
    wc.hIconSm = LoadIcon(NULL, IDI_APPLICATION);

    if(!(RegisterClassEx(&wc)))
    {
        return (1);
    }

    rect.left = 0;
    rect.top = 0;
    rect.right = shiirka;
    rect.bottom = vyyshka;

    if(!(AdjustWindowRectEx(&rect, TEST | WS_CAPTION,
                            FALSE, WS_EX_CLIENTEDGE)))
    {
        return (2);
    }

    hwnd = CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName, nadpis,
                          TEST, CW_USEDEFAULT, CW_USEDEFAULT,
                          rect.right - (rect.left), rect.bottom - (rect.top),
                          NULL, NULL, hInstance, NULL);

    okno->hwnd = hwnd;

    ShowWindow(hwnd, SW_SHOW);
    UpdateWindow(hwnd);

    return (0);
}

NNHK_OKNO *nnhk_VytvorOkno(const char *nadpis,
                           int xPoz, int yPoz,
                           int shiirka, int vyyshka,
                           int vlajky)
{
    NNHK_OKNO *okno = malloc(sizeof(NNHK_OKNO));

    if (okno == NULL) return (NULL);

    okno->povrch = NULL;

    if (_windowsVytvorOkno(okno, nadpis,
                           xPoz, yPoz,
                           shiirka, vyyshka,
                           vlajky))
    {
        free(okno);

        return (NULL);
    }

    return (okno);
}

static void _windowsUvolhiPovrch(NNHK_POVRCH *povrch)
{
    DeleteObject((HBITMAP *)(povrch->internee));
    free(povrch->internee2);
}

void nnhk_UvolhniPovrch(NNHK_POVRCH *povrch)
{
    _windowsUvolhiPovrch(povrch);
    free(povrch);
}

static void _windowsZnicshOkno(NNHK_OKNO *okno)
{
    DestroyWindow(okno->hwnd);
}

void nnhk_ZnicshOkno(NNHK_OKNO *okno)
{
    if (okno->povrch)
    {
        nnhk_UvolhniPovrch(okno->povrch);
    }
    _windowsZnicshOkno(okno);

    free(okno);
}

static void _windowsAktualizujOkno(NNHK_OKNO *okno)
{
    HDC hdc = GetDC(okno->hwnd);
    RECT rcClient;

    GetClientRect(okno->hwnd, &rcClient);

    if (okno->povrch)
    {
        SetDIBitsToDevice(hdc,
                          0, 0, rcClient.right, rcClient.bottom,
                          0, 0, 0, rcClient.bottom,
                          okno->povrch->pixely,
                          (BITMAPINFO *)(okno->povrch->internee2),
                          DIB_RGB_COLORS);
    }

    ReleaseDC(okno->hwnd, hdc);
}

void nnhk_aktualizujOkno(NNHK_OKNO *okno)
{
    _windowsAktualizujOkno(okno);
}

static int _windowsDajOknaPovrch(NNHK_OKNO *okno, NNHK_POVRCH *povrch)
{
    BITMAPV5HEADER *bmh;
    HDC hdc;
    RECT clientRect;

    povrch->internee2 = malloc(sizeof(BITMAPV5HEADER));
    if (povrch->internee2 == NULL) return (1);

    if (GetClientRect(okno->hwnd, &clientRect) == 0)
    {
        free(povrch->internee2);

        return (1);
    }

    hdc = GetDC(okno->hwnd);

    bmh = povrch->internee2;

    ZeroMemory(bmh, sizeof(BITMAPV5HEADER));
    bmh->bV5Size = sizeof(BITMAPV5HEADER);
    bmh->bV5Width = clientRect.right;
    bmh->bV5Height = clientRect.bottom;
    bmh->bV5Planes = 1;
    bmh->bV5BitCount = 32;
    bmh->bV5Compression = BI_RGB;

    povrch->internee = CreateDIBSection(hdc,
                                        (BITMAPINFO *)bmh,
                                        DIB_RGB_COLORS,
                                        &(povrch->pixely),
                                        NULL,
                                        0);

    ReleaseDC(okno->hwnd, hdc);

    if (povrch->internee == NULL)
    {
        free(povrch->internee2);
        return (2);
    }

    return (0);
}

NNHK_POVRCH *nnhk_dajOknaPovrch(NNHK_OKNO *okno)
{
    NNHK_POVRCH *povrch;

    if (okno == NULL) return (NULL);

    povrch = malloc(sizeof(NNHK_POVRCH));
    if (povrch == NULL) return (NULL);

    if (okno->povrch) printf("NEHOTOVEE!\n");

    if (_windowsDajOknaPovrch(okno, povrch))
    {
        free(povrch);

        return (NULL);
    }

    okno->povrch = povrch;

    return (povrch);
}

void nnhk_inic(void)
{
    ;
}

void nnhk_koniec(void)
{
    if (chytenee_okno)
    {
        ClipCursor(NULL);
    }
}

void nnhk_OknoNastavChytenie(NNHK_OKNO *okno,
                             int nastavenie)
{
    if (nastavenie)
    {
        SetCapture(okno->hwnd);

        {
            long xStred, yStred;
            RECT rcOkno, rcClient;

            if (GetWindowRect(okno->hwnd, &rcOkno) == 0
                || GetClientRect(okno->hwnd, &rcClient) == 0)
            {
                printf("zle\n");
            }

            xStred = (rcOkno.right - rcClient.right) + rcClient.right / 2;
            yStred = (rcOkno.bottom - rcClient.bottom) + rcClient.bottom / 2;

            SetCursorPos(xStred, yStred);
            ClipCursor(&rcOkno);
        }

        {
            POINT bod;
            if (GetCursorPos(&bod) == 0) printf("zle\n");

            myshPredPozX = bod.x;
            myshPredPozY = bod.y;
        }

        chytenee_okno = okno;
    }
    else
    {
        if (okno == chytenee_okno)
        {
            ClipCursor(NULL);
            ReleaseCapture();
            chytenee_okno = NULL;
        }
    }
}
