/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#ifndef NNHK_H
#define NNHK_H

#define NNHK_KONIEC            5
#define STLACSHENEE_TLACSHIDLO 1
#define PUSTENEE_TLACSHIDLO    2
#define MYSH_POHYB             3
#define STRATA_DRZHANIA        4

/* Virtuaalne tlacshidlaa. */
#define VT_ESC    0x1B
#define VT_VLHAVO 0x25
#define VT_HORE   0x26
#define VT_VPRAVO 0x27
#define VT_DOLE   0x28
#define VT_F      0x46
#define VT_G      0x47
#define VT_H      0x48
#define VT_I      0x49
#define VT_J      0x4A
#define VT_K      0x4B
#define VT_L      0x4C
#define VT_M      0x4D
#define VT_N      0x4E
#define VT_O      0x4F
#define VT_P      0x50

#define NNHK_OKNO_VIDITHELNEE 0

typedef struct _nnhk_okno NNHK_OKNO;
typedef struct {
    int sh;
    int v;
    void *pixely;
    void *internee;
    void *internee2;
} NNHK_POVRCH;

typedef struct _udalosth {
    int typ;
    union {
        int tlacshidlo;

        struct {
            struct {
                long x;
                long y;
            } poz;

            struct {
                long x;
                long y;
            } rel;
        } mysh_pohyb;
    } daata;
    struct _udalosth *dalshia;
} UDALOSTH;

void nnhk_inic(void);
void nnhk_koniec(void);

NNHK_OKNO *nnhk_VytvorOkno(const char *nadpis,
                           int xPoz, int yPoz,
                           int shiirka, int vyyshka,
                           int vlajky);
void nnhk_ZnicshOkno(NNHK_OKNO *okno);
void nnhk_aktualizujOkno(NNHK_OKNO *okno);

NNHK_POVRCH *nnhk_dajOknaPovrch(NNHK_OKNO *okno);
void nnhk_UvolhniPovrch(NNHK_POVRCH *povrch);

void nnhk_OknoNastavChytenie(NNHK_OKNO *okno,
                             int nastavenie);

int udalosthOdober(UDALOSTH *uu);
void nastav_chytenie_myshi(int nastavenie);

#endif /* NNHK_H */
