/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "zaaklad/typy.h"

#define k32(u) ((((u) >> 24) & 0x000000ff) \
                | (((u) << 8) & 0x00ff0000) \
                | (((u) >> 8) & 0x0000ff00) \
                | (((u) >> 24) & 0xff000000))

#define k16(u) ((((u) << 8) & 0xff00) \
                | (((u) >> 8) & 0x00ff))

static void printTag(ULONG *tag)
{
    int i;
    char *p = (char *)tag;

    for (i = 0; i < 4; i++)
    {
        printf("%c", p[i]);
    }
}

static int ushortCsh(FILE *s, USHORT *us)
{
    if (fread(us, 2, 1, s) != 1) return (2);
    *us = k16(*us);

    return (0);
}

static int ulongCsh(FILE *s, ULONG *ul)
{
    if (fread(ul, 4, 1, s) != 1) return (2);
    *ul = k32(*ul);

    return (0);
}

#define JN(n) do {v = (n); if (v) return (v);} while (0)

static int offset_tableCsh(FILE *s, OFFSET_TABLE *ot)
{
    int v = 0;

    if (fread(ot->sfnt_version, 4, 1, s) != 1) return (2);
    if (memcmp(ot->sfnt_version, "OTTO", 4) != 0
        && memcmp(ot->sfnt_version, "\0\x01\0\0", 4) != 0) return (1);

    JN(ushortCsh(s, &(ot->numTables)));
    JN(ushortCsh(s, &(ot->searchRange)));
    JN(ushortCsh(s, &(ot->entrySelector)));
    JN(ushortCsh(s, &(ot->rangeShift)));

    printf("%u %u %u %u\n", ot->numTables, ot->searchRange,
           ot->entrySelector, ot->rangeShift);

    return (0);
}

static int table_recordCsh(FILE *s, TABLE_RECORD *tr)
{
    int v = 0;

    if (fread(&(tr->tag), 4, 1, s) != 1) return (2);

    JN(ulongCsh(s, &(tr->checkSum)));
    JN(ulongCsh(s, &(tr->Offset)));
    JN(ulongCsh(s, &(tr->length)));

    printTag(&(tr->tag));
    printf(" %lu %lu %lu\n", tr->checkSum, tr->Offset,
           tr->length);

    return (0);
}

static int fontFont(FILE *s)
{
    int i;
    int v = 0;
    OFFSET_TABLE ot;
    TABLE_RECORD tr;

    JN(offset_tableCsh(s, &ot));

    for (i = 0; i < (ot.numTables); i++)
    {
        JN(table_recordCsh(s, &tr));
    }

    return (0);
}

/* 1 */

void kresli(unsigned long *pixely)
{
    int i;

    for (i = 0; i < 640 * 480; i++)
    {
        pixely[i] = 0x00ffffff;
    }
}
