/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include "font.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "typy.h"
#include "../analyz/analyz.h"
#include "../taby/taby.h"
#include "../cff/charstring.h"

static void fontInit(FONT *font)
{
    memset(font, 0, sizeof(FONT));
}

FONT *fontNacshitaj(const char *meno)
{
    FONT *font = malloc(sizeof(FONT));

    if (font == NULL) return (NULL);

    fontInit(font);

    if (analyzSuubor(font, meno))
    {
        fontUvolhni(font);

        return (NULL);
    }

    return (font);
}

void fontUvolhni(FONT *font)
{
    if (font->taby)
    {
        int i;

        for (i = 0; i < font->numTables; i++)
        {
            tabulhkaUvolhni(font->taby + i);
        }
        free(font->taby);
    }

    free(font);
}

int fontZobrazZnak(FONT *font, char znak, unsigned long *obraz)
{
    CFF_TAB *cff_tab = daj_cff(font);
    CFF *cff;

    if (cff_tab == NULL)
    {
        printf("cff_tab == NULL\n");
        return (1);
    }

    cff = cff_tab->daata;

    return (pracuj(cff, obraz));
}
