/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#ifndef TYPY_H
#define TYPY_H

#include <stdio.h>

#define BYTE unsigned char /* 8 bitov bez znamienka. */
#define CHAR signed char /* 8 bitov so znamienkom. */
#define USHORT unsigned short /* 16 bitov bez znamienka. */
#define SHORT signed short /* 16 bitov so znamienkom. */

#define UINT24

#define ULONG unsigned long /* 32 bitov bez znamienka. */
#define LONG signed long /* 32 bitov so znamienkom. */

#define Fixed long

typedef struct {
    unsigned char daata[8];
} LONGDATETIME;

#define FWORD SHORT
#define UFWORD USHORT

#define TAG_CMAP 0x636D6170 /* cmap */
#define TAG_HEAD 0x68656164 /* head */
#define TAG_HHEA 0x68686561 /* hhea */
#define TAG_HMTX 0x686D7478 /* hmtx */
#define TAG_MAXP 0x6D617870 /* maxp */
#define TAG_NAME 0x6E616D65 /* name */
#define TAG_OS_2 0x4F532F32 /* OS/2 */
#define TAG_POST 0x706F7374 /* post */

/* TrueType. */
#define TAG_LOCA 0x6c6f6361 /* loca */
#define TAG_GLYF 0x676c7966 /* glyf */
#define TAG_CVT  0x63767420 /* cvt  */
#define TAG_FPGM 0x6670676d /* fpgm */
#define TAG_PREP 0x70726570 /* prep */

/* CFF. */
#define TAG_CFF  0x43464620 /* cff */

enum {STAV_NEHOTOVEE, STAV_HOTOVEE, STAV_NEZNAAME, STAV_CHYBA};

#define MAXP_CFF_DATA 0x00005000
#define MAXP_TRUETYPE 0x00010000

typedef struct {
    USHORT platformID;
    USHORT encodingID;
    ULONG Offset;

    USHORT format;
    USHORT length;
    USHORT language;

    unsigned long pocshetIndexov;
    unsigned long *glyf_indexy;
} CMAP_SUBTAB;

typedef struct {
    USHORT Version;
    USHORT numTables;

    CMAP_SUBTAB *cmap_subtaby;
} CMAP_TAB;

typedef struct {
    Fixed Table_version_number;
    Fixed fontRevision;
    ULONG checkSumAdjustment;
    ULONG magicNumber; /* 0x5F0F3CF5 */
    USHORT flags;
    USHORT unitsPerEm;
    LONGDATETIME created;
    LONGDATETIME modified;
    SHORT xMin;
    SHORT yMin;
    SHORT xMax;
    SHORT yMax;
    USHORT macStyle;
    USHORT lowestRecPPEM;
    SHORT fontDirectionHint;
    SHORT indexToLocFormat;
    SHORT glyphDataFormat;
} HEAD_TAB;

typedef struct {
    Fixed Table_version_number;
    FWORD Ascender;
    FWORD Descender;
    FWORD LineGap;
    UFWORD advanceWidthMax;
    FWORD minLeftSideBearing;
    FWORD minRightSideBearing;
    FWORD xMaxExtend;
    SHORT caretSlopeRise;
    SHORT caretSlopeRun;
    SHORT caretOffset;
    /* SHORT reserved; */
    /* SHORT reserved; */
    /* SHORT reserved; */
    /* SHORT reserved; */
    SHORT metricDataFormat;
    USHORT numberOfHMetrics;
} HHEA_TAB;

typedef struct {
    USHORT advanceWidth;
    SHORT lsb;
} longHorMetric;

typedef struct {
    longHorMetric *hMetrics;
    SHORT *leftSideBearing;
} HMTX_TAB;

typedef struct {
    Fixed Table_version_number;
    USHORT numGlyphs;
    /* Table_version_number == MAXP_TRUETYPE */
    USHORT maxPoints;
    USHORT maxContours;
    USHORT maxCompositePoints;
    USHORT maxCompositeContours;
    USHORT maxZones;
    USHORT maxTwilightPoints;
    USHORT maxStorage;
    USHORT maxFunctionDefs;
    USHORT maxInstructionDefs;
    USHORT maxStackElements;
    USHORT maxSizeOfInstructions;
    USHORT maxComponentElements;
    USHORT maxComponentDepth;
} MAXP_TAB;

typedef struct {
    USHORT Version;
    SHORT xAvgCharWidth;
    USHORT usWeightClass;
    USHORT usWidthClass;
    USHORT fsType;
    SHORT ySubscriptXSize;
    SHORT ySubscriptYSize;
    SHORT ySubscriptXOffset;
    SHORT ySubscriptYOffset;
    SHORT ySuperscriptXSize;
    SHORT ySuperscriptYSize;
    SHORT ySuperscriptXOffset;
    SHORT ySuperscriptYOffset;
    SHORT yStrikeoutSize;
    SHORT yStrikeoutPosition;
    SHORT sFamilyClass;
    BYTE Panose[10];
    ULONG ulUnicodeRange1;
    ULONG ulUnicodeRange2; /* Version >= 0x0001 */
    ULONG ulUnicodeRange3; /* Version >= 0x0001 */
    ULONG ulUnicodeRange4; /* Version >= 0x0001 */
    CHAR achVendID[4];
    USHORT fsSelection;
    USHORT usFirstCharIndex;
    USHORT usLastCharIndex;
    SHORT sTypoAscender;
    SHORT sTypoDescender;
    SHORT sTypoLineGap;
    USHORT usWinAscent;
    USHORT usWinDescent;
    ULONG ulCodePageRange1; /* Version >= 0x0001 */
    ULONG ulCodePageRange2; /* Version >= 0x0001 */
    SHORT sxHeight; /* Version >= 0x0002 */
    SHORT sCapHeight; /* Version >= 0x0002 */
    USHORT usDefaultChar; /* Version >= 0x0002 */
    USHORT usBreakChar; /* Version >= 0x0002 */
    USHORT usMaxContext; /* Version >= 0x0002 */
} OS_2_TAB;

typedef struct {
    Fixed Version;
    Fixed italicAngle;
    FWORD underlinePosition;
    FWORD underlineThickness;
    ULONG isFixedPitch;
    ULONG minMemType42;
    ULONG maxMemType42;
    ULONG minMemType1;
    ULONG maxMemType1;
    /* Version == 0x00020000 */
    USHORT numberOfGlyphs;
    USHORT *glyphNameIndex;
    CHAR **names;
} POST_TAB;

typedef struct {
    ULONG *Offsets;
} LOCA_TAB;

typedef struct {
    FWORD *hodnoty;
    unsigned long n; /* tab->length / sizeof(FWORD) */
} CVT_TAB;

typedef struct {
    BYTE *Instructions;
    unsigned long n; /* tab->length / sizeof(BYTE) */
} FPGM_TAB;

typedef struct {
    BYTE *Instructions;
    unsigned long n; /* tab->length / sizeof(BYTE) */
} PREP_TAB;

#define FLAG_On_Curve       0x01
#define FLAG_x_Short_Vector 0x02
#define FLAG_y_Short_Vector 0x04
#define FLAG_Repeat         0x08
#define FLAG_This_x_is_same 0x10
#define FLAG_This_y_is_same 0x20

typedef struct {
    USHORT *endPtsOfContours;
    USHORT instructionLength;
    BYTE *instructions;
    BYTE *flags;
    SHORT *xCoordinates;
    SHORT *yCoordinates;

    USHORT pocshetBodov; /* endPtsOfContours[-1] */
} SIMPLE_GLYPH_DESCRIPTION;

typedef struct {
    SHORT numberOfContours;
    SHORT xMin;
    SHORT yMin;
    SHORT xMax;
    SHORT yMax;

    union {
        SIMPLE_GLYPH_DESCRIPTION sgd;
    } Description;
} GLYPH;

typedef struct {
    GLYPH *glyphy;
    USHORT n;
} GLYF_TAB;

struct _cff;

typedef struct {
    struct _cff *daata;
} CFF_TAB;

typedef struct {
    ULONG tag;
    ULONG checkSum;
    ULONG Offset;
    ULONG length;

    int stav;

    union {
        CMAP_TAB cmap;
        HEAD_TAB head;
        HHEA_TAB hhea;
        HMTX_TAB hmtx;
        MAXP_TAB maxp;
        OS_2_TAB os_2;
        POST_TAB post;
        LOCA_TAB loca;
        CVT_TAB cvt;
        FPGM_TAB fpgm;
        PREP_TAB prep;
        GLYF_TAB glyf;
        CFF_TAB cff;
    } daata;
} TABLE_RECORD;

typedef struct {
    FILE *f;

    Fixed sfnt_version;
    USHORT numTables;
    USHORT searchRange;
    USHORT entrySelector;
    USHORT rangeShift;

    TABLE_RECORD *taby;
} FONT;

#endif /* TYPY_H */
